Index: trunk/kernel/kern/process.c
===================================================================
--- trunk/kernel/kern/process.c	(revision 690)
+++ trunk/kernel/kern/process.c	(revision 1)
@@ -1647,1500 +578,267 @@
     }
 
-    // release the lock protecting th_tbl
-    if( thread->type != THREAD_IDLE ) rwlock_wr_release( &process->th_lock );
-
-    return (found) ? 0 : -1;
-
-}  // end process_register_thread()
-
-///////////////////////////////////////////////////
-uint32_t process_remove_thread( thread_t * thread )
-{
-    uint32_t count;  // number of threads in local process descriptor
-
-// check thread
-assert( __FUNCTION__, (thread != NULL) , "thread argument is NULL" );
-
+    return (found) ? 0 : ENOMEM;
+}
+    
+///////////////////////////////////////////////
+void process_remove_thread( thread_t * thread )
+{
+    if( thread == NULL )
+    {
+        printk("\n[PANIC] in %s : thread argument is NULL\n", __FUNCTION__ );
+        hal_core_sleep();
+    }
+    
     process_t * process = thread->process;
 
     // get thread local index
     ltid_t  ltid = LTID_FROM_TRDID( thread->trdid );
-    
-    // get the lock protecting th_tbl[]
-    rwlock_wr_acquire( &process->th_lock );
-
-    // get number of threads
-    count = process->th_nr;
-
-// check th_nr value
-assert( __FUNCTION__, (count > 0) , "process th_nr cannot be 0" );
 
     // remove thread from th_tbl[]
     process->th_tbl[ltid] = NULL;
-    process->th_nr = count-1;
-
-    // release lock protecting th_tbl
-    rwlock_wr_release( &process->th_lock );
-
-    return count;
-
-}  // end process_remove_thread()
-
-/////////////////////////////////////////////////////////
-error_t process_make_fork( xptr_t      parent_process_xp,
-                           xptr_t      parent_thread_xp,
-                           pid_t     * child_pid,
-                           thread_t ** child_thread )
-{
-    process_t * process;         // local pointer on child process descriptor
-    thread_t  * thread;          // local pointer on child thread descriptor
-    pid_t       new_pid;         // process identifier for child process
-    pid_t       parent_pid;      // process identifier for parent process
-    xptr_t      ref_xp;          // extended pointer on reference process
-    xptr_t      vfs_bin_xp;      // extended pointer on .elf file
-    error_t     error;
-
-    // get cluster and local pointer for parent process
-    cxy_t       parent_process_cxy = GET_CXY( parent_process_xp );
-    process_t * parent_process_ptr = GET_PTR( parent_process_xp );
-
-    // get parent process PID and extended pointer on .elf file
-    parent_pid = hal_remote_l32 (XPTR( parent_process_cxy , &parent_process_ptr->pid));
-    vfs_bin_xp = hal_remote_l64(XPTR( parent_process_cxy , &parent_process_ptr->vfs_bin_xp));
-
-    // get extended pointer on reference process
-    ref_xp = hal_remote_l64( XPTR( parent_process_cxy , &parent_process_ptr->ref_xp ) );
-
-// check parent process is the reference process
-assert( __FUNCTION__, (parent_process_xp == ref_xp ) ,
-"parent process must be the reference process" );
-
-#if DEBUG_PROCESS_MAKE_FORK || DEBUG_PROCESS_ERROR
-uint32_t   cycle  = (uint32_t)hal_get_cycles();
-thread_t * this  = CURRENT_THREAD;
-trdid_t    trdid = this->trdid;
-pid_t      pid   = this->process->pid;
-#endif
-
-#if( DEBUG_PROCESS_MAKE_FORK & 1 )
-if( DEBUG_PROCESS_MAKE_FORK < cycle )
-printk("\n[%s] thread[%x,%x] enter / cluster %x / cycle %d\n",
-__FUNCTION__, pid, trdid, local_cxy, cycle );
-#endif
-
-    // allocate a process descriptor
-    process = kmem_alloc( bits_log2(sizeof(process_t)) , AF_ZERO );
+    process->th_nr--;
+}
+
+/////////////////////////////////////////////////////
+error_t process_make_exec( exec_info_t  * exec_info )
+{
+    char           * path;                            // pathname to .elf file
+    process_t      * process;                         // pointer on new process 
+    pid_t            pid;                             // new process pid
+    thread_t       * thread;                          // pointer on new thread
+    pthread_attr_t   attr;                            // main thread attributes
+    core_t         * core;                            // pointer on selected core
+    lid_t            lid;                             // selected core local index
+	error_t          error; 
+
+	// get pid and pathname to .elf file  
+	path  = exec_info->path;
+    pid   = exec_info->pid;
+    
+    if( CXY_FROM_PID( pid ) != local_cxy )
+    {
+        printk("\n[PANIC] in %s : illegal process PID %x in cluster %x\n",
+               __FUNCTION__ , pid , local_cxy );
+        hal_core_sleep();
+    }
+
+    exec_dmsg("\n[INFO] %s enters in cluster %x for process %x / path = %s\n",
+                __FUNCTION__ , local_cxy , pid , path );
+
+    // create new process descriptor
+    process = process_alloc();
 
     if( process == NULL )
     {
-
-#if DEBUG_PROCESS_ERROR
-printk("\n[ERROR] in %s : thread[%x,%x] cannot allocate process descriptor / cxy %x / cycle %d\n", 
-__FUNCTION__, pid, trdid, local_cxy, cycle ); 
-#endif
-        return -1;
-    }
-
-    // allocate a child PID from local cluster
-    error = cluster_pid_alloc( process , &new_pid );
-    if( error ) 
-    {
-
-#if DEBUG_PROCESS_ERROR
-printk("\n[ERROR] in %s : thread[%x,%x] cannot get PID / cxy %x / cycle %d\n", 
-__FUNCTION__, pid, trdid, local_cxy, cycle ); 
-#endif
-	    kmem_free( process , bits_log2(sizeof(process_t)) );
-        return -1;
-    }
-
-#if( DEBUG_PROCESS_MAKE_FORK & 1 )
-if( DEBUG_PROCESS_MAKE_FORK < cycle )
-printk("\n[%s] thread[%x,%x] allocated child_process %x\n",
-__FUNCTION__, pid, trdid, new_pid );
-#endif
-
-    // initializes child process descriptor from parent process descriptor 
-    error = process_reference_init( process,
-                                    new_pid,
-                                    parent_process_xp );
-    if( error ) 
-    {
-
-#if DEBUG_PROCESS_ERROR
-printk("\n[ERROR] in %s : thread[%x,%x] cannot initialize child process / cxy %x / cycle %d\n", 
-__FUNCTION__, pid, trdid, local_cxy, cycle ); 
-#endif
-        cluster_pid_release( new_pid );
-	    kmem_free( process , bits_log2(sizeof(process_t)) );
-        return -1;
-    }
-
-#if( DEBUG_PROCESS_MAKE_FORK & 1 )
-if( DEBUG_PROCESS_MAKE_FORK < cycle )
-printk("\n[%s] thread[%x,%x] initialized child_process %x\n",
-__FUNCTION__, pid, trdid, new_pid );
-#endif
-
-    // copy VMM from parent descriptor to child descriptor
-    error = vmm_fork_copy( process,
-                           parent_process_xp );
-    if( error )
-    {
-
-#if DEBUG_PROCESS_ERROR
-printk("\n[ERROR] in %s : thread[%x,%x] cannot copy VMM to child process / cxy %x / cycle %d\n", 
-__FUNCTION__, pid, trdid, local_cxy, cycle ); 
-#endif
-        cluster_pid_release( new_pid );
-	    kmem_free( process , bits_log2(sizeof(process_t)) );
-        return -1;
-    }
-
-#if( DEBUG_PROCESS_MAKE_FORK & 1 )
-if( DEBUG_PROCESS_MAKE_FORK < cycle )
-{
-    printk("\n[%s] thread[%x,%x] copied VMM from parent to child\n",
-    __FUNCTION__, pid, trdid );
-    hal_vmm_display( XPTR( local_cxy , process ) , true );
-}
-#endif
-
-    // if parent_process is INIT, or if parent_process is the TXT owner,
-    // the child_process becomes the owner of its TXT terminal
-    if( (parent_pid == 1) || process_txt_is_owner( parent_process_xp ) )
-    {
-        process_txt_set_ownership( XPTR( local_cxy , process ) );
-
-#if( DEBUG_PROCESS_MAKE_FORK & 1 )
-if( DEBUG_PROCESS_MAKE_FORK < cycle )
-printk("\n[%s] thread[%x,%x] / child_process %x takes TXT ownership\n",
-__FUNCTION__ , pid, trdid, new_pid );
-#endif
-
-    }
-
-    // update extended pointer on .elf file
-    process->vfs_bin_xp = vfs_bin_xp;
-
-    // create child thread descriptor from parent thread descriptor
-    error = thread_user_fork( parent_thread_xp,
-                              process,
-                              &thread );
-    if( error )
-    {
-
-#if DEBUG_PROCESS_ERROR
-printk("\n[ERROR] in %s : thread[%x,%x] cannot create main thread / cxy %x / cycle %d\n", 
-__FUNCTION__, pid, trdid, local_cxy, cycle ); 
-#endif
-        cluster_pid_release( new_pid );
-	    kmem_free( process , bits_log2(sizeof(process_t)) );
-        return -1;
-    }
-
-// check main thread LTID
-assert( __FUNCTION__, (LTID_FROM_TRDID(thread->trdid) == 0) ,
-"main thread must have LTID == 0" );
-
-#if( DEBUG_PROCESS_MAKE_FORK & 1 )
-if( DEBUG_PROCESS_MAKE_FORK < cycle )
-printk("\n[%s] thread[%x,%x] created main thread %x\n", 
-__FUNCTION__, pid, trdid, thread );
-#endif
-
-    // set COW flag in DATA, ANON, REMOTE vsegs in parent process VMM
-    // this includes all parent process copies in all clusters
-    if( parent_process_cxy == local_cxy )   // reference is local
-    {
-        vmm_set_cow( parent_process_ptr );
-    }
-    else                                    // reference is remote
-    {
-        rpc_vmm_set_cow_client( parent_process_cxy,
-                                parent_process_ptr );
-    }
-
-    // set COW flag in DATA, ANON, REMOTE vsegs for child process VMM
-    vmm_set_cow( process );
+        printk("\n[ERROR] in %s : no memory in cluster %x for process %x / path = %s\n",
+               __FUNCTION__ , local_cxy , pid , path );
+        return ENOMEM;
+    }
+
+    // initialize the process descriptor as the reference
+    process_reference_init( process , pid , exec_info->ppid );
+                                
+    // restore from exec_info the extended pointer on vfs root, cwd, and bin 
+    process->vfs_root_xp = exec_info->vfs_root_xp;
+    process->vfs_cwd_xp  = exec_info->vfs_cwd_xp;
+    process->vfs_bin_xp  = exec_info->vfs_bin_xp;
+
+    // restore from exec_info the embedded fd_array
+    process_fd_remote_copy( XPTR( local_cxy , &process->fd_array ), exec_info->fd_array_xp );
+                            
+    exec_dmsg("\n[INFO] %s restaured fd-array in cluster %x for process %x / path = %s\n",
+                __FUNCTION__, local_cxy , pid , path );
+
+	// initialize signal manager TODO ??? [AG]
+	// signal_manager_init( process );
+
+    // initialize process VMM
+	vmm_init( process );
+
+    exec_dmsg("\n[INFO] %s initialized VMM in cluster %x for process %x / path = %s\n",
+                __FUNCTION__ , local_cxy , pid , path );
+
+    // register "code" and "data" vsegs as well a the process entry-point in VMM,
+    // using informations contained in the elf file.
+	error = elf_load_process( path , process );
+
+	if( error )
+	{
+		printk("\n[ERROR] in %s : failed to access elf file for process %x / path = %s\n", 
+		       __FUNCTION__, pid , path );
+        process_destroy( process );
+        return error;
+	}
+
+    // create "heap" vseg descriptor
+    vseg_t * heap_vseg = vmm_create_vseg( process,
+                                          CONFIG_VMM_HEAP_BASE,
+                                          CONFIG_VMM_HEAP_SIZE,
+                                          VSEG_TYPE_HEAP );
+    if( heap_vseg == NULL )
+	{
+		printk("\n[ERROR] in %s : cannot create heap vseg for process %x / path = %s\n",
+		       __FUNCTION__, pid , path );
+        process_destroy( process );
+        return error;
+	}
+
+    // create "stack" vseg descriptor for associated main thread
+    vseg_t * stack_vseg = vmm_create_vseg( process,
+                                           0,             // base defined by VMM
+                                           0,             // size defined by VMM
+                                           VSEG_TYPE_STACK );
+    if( stack_vseg == NULL )
+	{
+		printk("\n[ERROR] in %s : cannot create stack vseg for process %x / path = %s\n",
+		       __FUNCTION__, pid , path );
+        process_destroy( process );
+        return error;
+	}
+
+    // select a core in cluster
+    lid  = cluster_select_local_core();
+    core = &LOCAL_CLUSTER->core_tbl[lid];
+
+    // initialize pthread attributes for main thread
+    attr.pid          = pid;
+    attr.entry_func   = (void*)process->vmm.entry_point;
+    attr.entry_args   = exec_info->args_pointers; 
+    attr.flags        = PT_FLAG_DETACH;             // main thread always detached
+    attr.cxy          = local_cxy;
+    attr.lid          = lid;
+
+    // create and initialise thread descriptor, link thread & process
+	error = thread_user_create( &thread, 
+                                &attr,
+                                stack_vseg->min,
+                                stack_vseg->max - stack_vseg->min );
+	if( error )
+	{
+		printk("\n[ERROR] in %s : cannot create thread for process %x / path = %s\n",
+		       __FUNCTION__, pid , path );
+        process_destroy( process );
+        return error;
+	}
+
+	// Register thread in scheduler 
+	sched_register_thread( core , thread );
+
+	exec_dmsg("\n[INFO] %s created thread for process %x on core %d in cluster %x\n",
+               __FUNCTION__ , process->pid , core->lid , local_cxy );
+
+    // activate new thread 
+	thread_unblock( XPTR( local_cxy , thread ) , THREAD_BLOCKED_GLOBAL );
+
+	return 0;
+
+} // end process_make_exec()
+
+//////////////////////////
+void process_init_create()
+{
+	process_t   * process_init;  // process_init descriptor 
+	thread_t    * thread_init;   // process_init main thread descriptor
+    pid_t         init_pid;      // process_init pid
+    exec_info_t   exec_info;     // structure to be passed to process_make_exec()
+
+	error_t error1 = 0;
+	error_t error2 = 0;
+	error_t error3 = 0;
+
+	process_dmsg("\n[INFO] %s enters in cluster %x\n", __FUNCTION__ , local_cxy );
+
+    // allocate memory for process descriptor
+    process_init = process_alloc();
+    if( process_init == NULL )
+    {
+        printk("\n[PANIC] in %s : no memory for process descriptor in cluster %x\n",
+               __FUNCTION__ , local_cxy );
+        hal_core_sleep();
+    }
+
+    // get a pid from the local cluster 
+    xptr_t xp_process = XPTR( local_cxy , process_init );
+    error1 = cluster_pid_alloc( xp_process , &init_pid );
+    if( error1 )
+    {
+        printk("\n[PANIC] in %s : cannot get PID in cluster %x\n", 
+               __FUNCTION__ , local_cxy );
+		hal_core_sleep();
+    }
  
-#if( DEBUG_PROCESS_MAKE_FORK & 1 )
-if( DEBUG_PROCESS_MAKE_FORK < cycle )
-printk("\n[%s] thread[%x,%x] set COW in DATA / ANON / REMOTE for parent and child\n",
-__FUNCTION__, pid, trdid );
-#endif
-
-    // get extended pointers on parent children_root, children_lock and children_nr
-    xptr_t children_root_xp = XPTR( parent_process_cxy , &parent_process_ptr->children_root );
-    xptr_t children_lock_xp = XPTR( parent_process_cxy , &parent_process_ptr->children_lock );
-    xptr_t children_nr_xp   = XPTR( parent_process_cxy , &parent_process_ptr->children_nr   );
-
-    // register process in parent children list
-    remote_queuelock_acquire( children_lock_xp );
-	xlist_add_last( children_root_xp , XPTR( local_cxy , &process->children_list ) );
-	hal_remote_atomic_add( children_nr_xp , 1 );
-    remote_queuelock_release( children_lock_xp );
-
-    // return success
-    *child_thread = thread;
-    *child_pid    = new_pid;
-
-#if DEBUG_PROCESS_MAKE_FORK
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_PROCESS_MAKE_FORK < cycle )
-printk("\n[%s] thread[%x,%x] exit / created process %x / cycle %d\n",
-__FUNCTION__, pid, trdid, new_pid, cycle );
-#endif
-
-    return 0;
-
-}   // end process_make_fork()
-
-#if DEBUG_PROCESS_MAKE_EXEC
-
-/////////////////////////////////////////////////////////////////////////////////////////
-// This static debug function displays the current state of the exec_info structure
-// embedded in the calling process descriptor.
-//
-// WARNING : It can be used after execution of the sys_exec function, but it cannot
-//           be used after execution of the process_make_exec() function, because the
-//           kernel pointers have been replaced by user pointers. 
-/////////////////////////////////////////////////////////////////////////////////////////
-static void process_exec_info_display( bool_t args_ok,
-                                       bool_t envs_ok )
-{
-    uint32_t   i;
-    char     * str;    // local pointer on a string
-
-    process_t * process = CURRENT_THREAD->process;
-
-    // get relevant info from calling process descriptor
-    pid_t       pid      = process->pid;
-
-    uint32_t    args_nr  = process->exec_info.args_nr;
-    char     ** args     = process->exec_info.args_pointers;
-
-    uint32_t    envs_nr  = process->exec_info.envs_nr;
-    char     ** envs     = process->exec_info.envs_pointers;
-
-    char      * path     = process->exec_info.path;
-
-    // get pointers on TXT0 chdev
-    xptr_t    txt0_xp  = chdev_dir.txt_tx[0];
-    cxy_t     txt0_cxy = GET_CXY( txt0_xp );
-    chdev_t * txt0_ptr = GET_PTR( txt0_xp );
-
-    // get extended pointer on remote TXT0 lock
-    xptr_t  lock_xp = XPTR( txt0_cxy , &txt0_ptr->wait_lock );
-
-    // get TXT0 lock 
-    remote_busylock_acquire( lock_xp );
-
-    nolock_printk("\n***** exec_info for process %x in cluster %x / %s\n",
-    pid , local_cxy , path ); 
-
-    // display arguments if required
-    if( args_ok )
-    {
-        for( i = 0 ; i < args_nr ; i++ )
-        {
-            str = args[i];
-            if( str != NULL)         // display pointer and string
-            nolock_printk(" - &arg[%d] = %x / arg[%d] = <%s>\n", i, str, i, str );
-            else                     // display WARNING
-            nolock_printk(" - unexpected NULL pointer for &arg[%d]\n", i );
-        }
-    }
-
-    // display env variables if required
-    if( envs_ok )
-    {
-        for( i = 0 ; i < envs_nr ; i++ )
-        {
-            str = envs[i];
-            if( str != NULL)     // display pointer and string
-            nolock_printk(" - &env[%d] = %x / env[%d] = <%s>\n", i, str, i, str );
-            else                     // display WARNING 
-            nolock_printk(" - unexpected NULL pointer for &env[%d]\n", i );
-        }
-    }
-
-    // release TXT0 lock 
-    remote_busylock_release( lock_xp );
-
-}  // end process_exec_info_display()
-
-#endif // DEBUG_PROCESS_MAKE_EXEC
-
-/////////////////////////////////
-error_t process_make_exec( void )
-{
-    thread_t       * this;                    // local pointer on this thread
-    process_t      * process;                 // local pointer on this process
-    pid_t            pid;                     // this process identifier
-    trdid_t          trdid;                   // this thread identifier
-    xptr_t           ref_xp;                  // reference process for this process
-	error_t          error;                   // value returned by called functions
-    char           * elf_path;                // path to .elf file
-    xptr_t           file_xp;                 // extended pointer on .elf file descriptor
-    uint32_t         file_id;                 // file index in fd_array
-    vseg_t         * vseg;                    // local pointer on created vseg(s)
-    uint32_t         n;                       // index for loops
-
-    uint32_t         args_nr;                 // actual number of args (from exec_info)
-    intptr_t         args_base;               // args vseg base address in user space
-    uint32_t         args_size;               // args vseg size (bytes)
-
-    uint32_t         envs_nr;                 // actual number of envs (from exec_info)
-    intptr_t         envs_base;               // envs vseg base address in user space
-    uint32_t         envs_size;               // envs vseg size (bytes)
-
-#if DEBUG_PROCESS_MAKE_EXEC || DEBUG_PROCESS_ERROR
-uint32_t cycle = (uint32_t)hal_get_cycles();
-#endif
-
-    // get calling thread, process, pid, trdid, and ref_xp 
-    this    = CURRENT_THREAD;
-    process = this->process;
-    pid     = process->pid;
-    trdid   = this->trdid;
-    ref_xp  = process->ref_xp;
-
-	// get .elf pathname from exec_info structure
-	elf_path      = process->exec_info.path;
-
-#if DEBUG_PROCESS_MAKE_EXEC
-if( DEBUG_PROCESS_MAKE_EXEC < cycle )
-printk("\n[%s] thread[%x,%x] enters for <%s> / cycle %d\n",
-__FUNCTION__, pid, trdid, elf_path, cycle );
-#endif
-
-    // 1. open the file identified by <path>
-    file_xp = XPTR_NULL;
-    file_id = 0xFFFFFFFF;
-	error   = vfs_open( process->vfs_root_xp,
-	                    elf_path,
-                        ref_xp,
-	                    O_RDONLY,
-	                    0,
-	                    &file_xp,
-	                    &file_id );
-	if( error )
-	{
-
-#if DEBUG_PROCESS_ERROR
-printk("\n[ERROR] in %s : thread[%x,%x] failed to open file <%s> / cycle %d\n", 
-__FUNCTION__, pid, trdid, elf_path, cycle ); 
-#endif
-		return -1;
+    // initializes process_init descriptor as the reference
+	process_reference_init( process_init , init_pid , process_zero.pid );
+
+    // initialize process_init VMM
+	vmm_init( process_init );
+
+    // initializes vfs_root and vfs_cwd from process_zero
+	vfs_file_count_up( process_zero.vfs_root_xp );
+	process_init->vfs_root_xp = process_zero.vfs_root_xp;
+
+	vfs_file_count_up( process_zero.vfs_cwd_xp );
+	process_init->vfs_cwd_xp  = process_zero.vfs_cwd_xp;
+
+    // update children list in process_zero
+	xlist_add_last( XPTR( local_cxy , &process_zero.children_root ),
+                    XPTR( local_cxy , &process_init->brothers_list ) );
+	process_zero.children_nr = 1;
+
+    // TODO open stdin / stdout / stderr pseudo-files
+    xptr_t  stdin_xp;
+    xptr_t  stdout_xp;
+    xptr_t  stderr_xp; 
+
+	// error1 = vfs_open( process_init->vfs_cwd_xp, NULL, VFS_O_RDONLY, &stdin_xp );
+	// error2 = vfs_open( process_init->vfs_cwd_xp, NULL, VFS_O_WRONLY, &stdout_xp );
+	// error3 = vfs_open( process_init->vfs_cwd_xp, NULL, VFS_O_WRONLY, &stderr_xp );
+
+	if( error1 || error2 || error3 )
+	{
+		if( !error1 ) vfs_close( stdin_xp  , NULL );
+		if( !error2 ) vfs_close( stdout_xp , NULL );
+		if( !error3 ) vfs_close( stderr_xp , NULL );
+    
+		printk("\n[PANIC] in %s : cannot open stdin/stdout/stderr in cluster %x\n",
+               __FUNCTION__ , local_cxy );
+        hal_core_sleep();
 	}
 
-#if (DEBUG_PROCESS_MAKE_EXEC & 1)
-if( DEBUG_PROCESS_MAKE_EXEC < cycle )
-printk("\n[%s] thread[%x,%x] opened file <%s>\n",
-__FUNCTION__, pid, trdid, elf_path );
-#endif
-
-    // 2. delete all threads other than this main thread in all clusters
-    process_sigaction( pid , DELETE_ALL_THREADS );
-
-#if (DEBUG_PROCESS_MAKE_EXEC & 1)
-if( DEBUG_PROCESS_MAKE_EXEC < cycle )
-printk("\n[%s] thread[%x,%x] deleted existing threads\n",
-__FUNCTION__, pid, trdid );
-#endif
-
-    // 3. reset calling process VMM
-    vmm_user_reset( process );
-
-#if( DEBUG_PROCESS_MAKE_EXEC & 1 )
-if( DEBUG_PROCESS_MAKE_EXEC < cycle )
-{
-    printk("\n[%s] thread[%x,%x] completed VMM reset\n",
-    __FUNCTION__, pid, trdid );
-    hal_vmm_display( ref_xp , true );
-}
-#endif
-
-    // 4. register the "args" vseg in VSL and map it in GPT, if args_nr != 0.
-    //    As this vseg contains an array of pointers, the kernel pointers 
-    //    are replaced by user pointers in new process space.
-    args_nr = process->exec_info.args_nr;
-
-    if( args_nr > 0 )
-    {
-        // get args vseg base and size in user space
-        args_base = CONFIG_VMM_UTILS_BASE << CONFIG_PPM_PAGE_ORDER;
-        args_size = CONFIG_VMM_ARGS_SIZE << CONFIG_PPM_PAGE_ORDER;
-
-        // create and register args vseg in VMM
-        vseg = vmm_create_vseg( process,
-                                VSEG_TYPE_DATA,
-                                args_base,
-                                args_size,
-                                0,                 // file_offset unused for DATA type
-                                0,                 // file_size unused for DATA type
-                                XPTR_NULL,         // mapper_xp unused for DATA type
-                                0 );               // cxy unused for DATA type
-        if( vseg == NULL )
-        {
-
-#if DEBUG_PROCESS_ERROR
-printk("\n[ERROR] in %s : thread[%x,%x] cannot create args vseg for <%s> / cycle %d\n", 
-__FUNCTION__, pid, trdid, elf_path, cycle ); 
-#endif
-		     return -1;
-        }
-
-#if( DEBUG_PROCESS_MAKE_EXEC & 1 )
-if( DEBUG_PROCESS_MAKE_EXEC < cycle )
-{
-    printk("\n[%s] thread[%x,%x] args vseg registered in new process VSL\n",
-    __FUNCTION__, pid, trdid );
-    hal_vmm_display( ref_xp , true );
-}
-#endif
-        // map all pages for the "args" vseg
-        uint32_t fake_attr;   // required for hal_gpt_lock_pte()
-        ppn_t    fake_ppn;    // required for hal_gpt_lock_pte()
-
-        xptr_t   base_xp = XPTR( local_cxy , process->exec_info.args_pointers );
-        xptr_t   gpt_xp  = XPTR( local_cxy , &process->vmm.gpt );
-        uint32_t attr    = GPT_MAPPED | GPT_SMALL | GPT_READABLE | GPT_USER | GPT_CACHABLE;
-        vpn_t    vpn     = CONFIG_VMM_UTILS_BASE;
-        ppn_t    ppn     = ppm_base2ppn( base_xp );
-
-        for( n = 0 ; n < CONFIG_VMM_ARGS_SIZE ; n++ )  
-        {
-            // lock the PTE
-            if (hal_gpt_lock_pte( gpt_xp , vpn + n , &fake_attr , &fake_ppn ) )
-            {
-
-#if DEBUG_PROCESS_ERROR
-printk("\n[ERROR] in %s : thread[%x,%x] cannot map vpn[%x] of args vseg for <%s> / cycle %d\n", 
-__FUNCTION__, pid, trdid,  vpn + n , elf_path , cycle ); 
-#endif
-		        return -1;
-            }
-
-            // map and unlock the PTE
-            hal_gpt_set_pte( gpt_xp , vpn + n , attr , ppn + n );
-       }
-
-#if( DEBUG_PROCESS_MAKE_EXEC & 1 )
-if( DEBUG_PROCESS_MAKE_EXEC < cycle )
-{
-    printk("\n[%s] thread[%x,%x] args vseg mapped in new process GPT\n",
-    __FUNCTION__, pid, trdid );
-    hal_vmm_display( ref_xp , true );
-    process_exec_info_display( true , false );   // args & not envs
-}
-#endif
-
-        // build pointer on args buffer in kernel space
-        char  ** k_args = process->exec_info.args_pointers;
-
-        // build pointer on args buffer in user space
-        char  ** u_args = (char **)args_base;
-
-        // set user space pointers in kernel args buffer
-        for( n = 0 ; n < args_nr ; n++ )
-        {
-            k_args[n] = (char *)((intptr_t)k_args[n] + (intptr_t)u_args - (intptr_t)k_args);
-        } 
-
-#if( DEBUG_PROCESS_MAKE_EXEC & 1 )
-if( DEBUG_PROCESS_MAKE_EXEC < cycle )
-printk("\n[%s] thread[%x,%x] args user pointers set in exec_info\n",
-__FUNCTION__, pid, trdid );
-#endif
-
-    }
-
-    // 5. register the "envs" vseg in VSL and map it in GPT, if envs_nr != 0.
-    //    As this vseg contains an array of pointers, the kernel pointers 
-    //    are replaced by user pointers in new process space.
-
-    envs_nr = process->exec_info.envs_nr;
-
-    if( envs_nr > 0 )
-    {
-        // get envs vseg base and size in user space from config
-        envs_base = (CONFIG_VMM_UTILS_BASE + CONFIG_VMM_ARGS_SIZE) << CONFIG_PPM_PAGE_ORDER;
-        envs_size = CONFIG_VMM_ENVS_SIZE << CONFIG_PPM_PAGE_ORDER;
-
-        // TODO (should be similar to the code for args above)
-
-#if( DEBUG_PROCESS_MAKE_EXEC & 1 )
-if( DEBUG_PROCESS_MAKE_EXEC < cycle )
-printk("\n[%s] thread[%x,%x] envs user pointers set in exec_info\n",
-__FUNCTION__, pid, trdid );
-#endif
-
-    }
-
-
-    // 6. register code & data vsegs, and entry-point in process VMM,
-    // register extended pointer on .elf file in process descriptor
-	error = elf_load_process( file_xp , process );
-
-    if( error )
-	{
-
-#if DEBUG_PROCESS_ERROR
-printk("\n[ERROR] in %s : thread[%x,%x] failed to access file <%s> / cycle %d\n", 
-__FUNCTION__, pid, trdid , elf_path , cycle ); 
-#endif
-        return -1;
-	}
-
-#if( DEBUG_PROCESS_MAKE_EXEC & 1 )
-if( DEBUG_PROCESS_MAKE_EXEC < cycle )
-{
-    printk("\n[%s] thread[%x,%x] registered code/data vsegs / entry %x\n",
-    __FUNCTION__, pid, trdid, process->vmm.entry_point );
-    hal_vmm_display( ref_xp , true );
-}
-#endif
-
-    // 7. allocate an user stack vseg for main thread
-    vseg = vmm_create_vseg( process,
-                            VSEG_TYPE_STACK,
-                            LTID_FROM_TRDID( trdid ),
-                            0,                 // length unused
-                            0,                 // file_offset unused
-                            0,                 // file_size unused
-                            XPTR_NULL,         // mapper_xp unused
-                            local_cxy );
-    if( vseg == NULL )
-    {
-
-#if DEBUG_PROCESS_ERROR
-printk("\n[ERROR] in %s : thread[%x,%x] failed to set u_stack vseg for <%s> / cycle %d\n", 
-__FUNCTION__, pid, trdid , elf_path , cycle ); 
-#endif
-		return -1;
-    }
-
-#if( DEBUG_PROCESS_MAKE_EXEC & 1 )
-if( DEBUG_PROCESS_MAKE_EXEC < cycle )
-{
-    printk("\n[%s] thread[%x,%x] registered stack vseg\n",
-    __FUNCTION__, pid, trdid );
-    hal_vmm_display( ref_xp , true );
-}
-#endif
-
-    // update user stack in thread descriptor
-    this->user_stack_vseg = vseg;
-
-    // 8. update the main thread descriptor ... and jumps (one way) to user code 
-    thread_user_exec( args_nr , args_base );
-
-    if( error )
-    {
-
-#if DEBUG_PROCESS_ERROR
-printk("\n[ERROR] in %s : thread[%x,%x] failed to set main thread for <%s> / cycle %d\n", 
-__FUNCTION__, pid, trdid , elf_path , cycle ); 
-#endif
-        return -1;
-    }
-
-    // should not be reached, avoid a warning
-	return 0;
-
-}  // end process_make_exec()
-
-
-////////////////////////////////////////////////
-void process_zero_create( process_t   * process,
-                          boot_info_t * info )
-{
-    error_t error;
-    pid_t   pid;
-
-#if DEBUG_PROCESS_ZERO_CREATE
-uint32_t cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_PROCESS_ZERO_CREATE < cycle )
-printk("\n[%s] enter / cluster %x / cycle %d\n",
-__FUNCTION__, local_cxy, cycle );
-#endif
-
-    // get pointer on VMM
-    vmm_t * vmm = &process->vmm;
-
-    // get PID from local cluster manager for this kernel process
-    error = cluster_pid_alloc( process , &pid );
-
-    if( error || (LPID_FROM_PID( pid ) != 0) )
-    {
-        printk("\n[PANIC] in %s : cannot get valid PID in cluster %x / PID = %x\n",
-        __FUNCTION__ , local_cxy, pid );
-        hal_core_sleep();
-    }
-
-#if (DEBUG_PROCESS_ZERO_CREATE & 1)
-if( DEBUG_PROCESS_ZERO_CREATE < cycle )
-printk("\n[%s] allocated pid %x in cluster %x\n", __FUNCTION__, pid, local_cxy );
-#endif
-
-    // initialize PID, REF_XP, PARENT_XP, and STATE
-    // the kernel process_zero is its own parent_process,
-    // reference_process, and owner_process, and cannot be killed...
-    process->pid        = pid;
-    process->ref_xp     = XPTR( local_cxy , process );
-    process->owner_xp   = XPTR( local_cxy , process );
-    process->parent_xp  = XPTR( local_cxy , process );
-    process->term_state = 0;
-
-    // initialize VSL as empty
-    vmm->vsegs_nr = 0;
-	xlist_root_init( XPTR( local_cxy , &vmm->vsegs_root ) );
-
-#if (DEBUG_PROCESS_ZERO_CREATE & 1)
-if( DEBUG_PROCESS_ZERO_CREATE < cycle )
-printk("\n[%s] initialized VSL empty in cluster %x\n", __FUNCTION__, local_cxy );
-#endif
-
-    // initialize GPT as empty
-    error = hal_gpt_create( &vmm->gpt );
-
-    if( error ) 
-    {
-        printk("\n[PANIC] in %s : cannot create empty GPT\n", __FUNCTION__ );
-        hal_core_sleep();
-    }
-
-#if (DEBUG_PROCESS_ZERO_CREATE & 1)
-if( DEBUG_PROCESS_ZERO_CREATE < cycle )
-printk("\n[%s] initialized GPT empty in cluster %x\n", __FUNCTION__, local_cxy );
-#endif
-
-    // initialize VSL and GPT locks
-    remote_rwlock_init( XPTR( local_cxy , &vmm->vsl_lock ) , LOCK_VMM_VSL );
-    
-    // create kernel vsegs in GPT and VSL, as required by the hardware architecture
-    error = hal_vmm_kernel_init( info );
-
-    if( error ) 
-    {
-        printk("\n[PANIC] in %s : cannot create kernel vsegs in VMM\n", __FUNCTION__ );
-        hal_core_sleep();
-    }
-
-#if (DEBUG_PROCESS_ZERO_CREATE & 1)
-if( DEBUG_PROCESS_ZERO_CREATE < cycle )
-printk("\n[%s] initialized hal specific VMM in cluster%x\n", __FUNCTION__, local_cxy );
-hal_vmm_display( XPTR( local_cxy , process ) , true ); 
-#endif
-
-    // reset th_tbl[] array and associated fields
-    uint32_t i;
-    for( i = 0 ; i < CONFIG_THREADS_MAX_PER_CLUSTER ; i++ )
-	{
-        process->th_tbl[i] = NULL;
-    }
-    process->th_nr  = 0;
-    rwlock_init( &process->th_lock , LOCK_PROCESS_THTBL );
-
-#if (DEBUG_PROCESS_ZERO_CREATE & 1)
-if( DEBUG_PROCESS_ZERO_CREATE < cycle )
-printk("\n[%s] initialized th_tbl[] in cluster%x\n", __FUNCTION__, local_cxy );
-#endif
-
-    // reset children list as empty
-    xlist_root_init( XPTR( local_cxy , &process->children_root ) );
-    process->children_nr = 0;
-    remote_queuelock_init( XPTR( local_cxy , &process->children_lock ),
-                           LOCK_PROCESS_CHILDREN );
-
-#if (DEBUG_PROCESS_ZERO_CREATE & 1)
-if( DEBUG_PROCESS_ZERO_CREATE < cycle )
-printk("\n[%s] initialized children list in cluster%x\n", __FUNCTION__, local_cxy );
-#endif
-
-    // register kernel process in cluster manager local_list
-    cluster_process_local_link( process );
-    
-	hal_fence();
-
-#if DEBUG_PROCESS_ZERO_CREATE
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_PROCESS_ZERO_CREATE < cycle )
-printk("\n[%s] exit / cluster %x / cycle %d\n",
-__FUNCTION__, local_cxy, cycle );
-#endif
-
-}  // end process_zero_create()
-
-////////////////////////////////
-void process_init_create( void )
-{
-    process_t      * process;       // local pointer on process descriptor
-    pid_t            pid;           // process_init identifier
-    thread_t       * thread;        // local pointer on main thread
-    pthread_attr_t   attr;          // main thread attributes
-    lid_t            lid;           // selected core local index for main thread
-    xptr_t           file_xp;       // extended pointer on .elf file descriptor
-    uint32_t         file_id;       // file index in fd_array
-    error_t          error;
-
-#if DEBUG_PROCESS_INIT_CREATE
-thread_t * this = CURRENT_THREAD;
-uint32_t cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_PROCESS_INIT_CREATE < cycle )
-printk("\n[%s] thread[%x,%x] enter / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, cycle );
-#endif
-
-    // allocates memory for process descriptor from local cluster
-    process = kmem_alloc( bits_log2(sizeof(process_t)) , AF_ZERO );
-    if( process == NULL )
-    {
-        printk("\n[PANIC] in %s : cannot allocate process\n", __FUNCTION__ );
-        hal_core_sleep();
-    }
-
-    // set the CWD and VFS_ROOT fields in process descriptor
-    process->cwd_xp      = process_zero.vfs_root_xp;
-    process->vfs_root_xp = process_zero.vfs_root_xp;
-
-    // get PID from local cluster
-    error = cluster_pid_alloc( process , &pid );
-    if( error ) 
-    {
-        printk("\n[PANIC] in %s : cannot allocate PID\n", __FUNCTION__ );
-        hal_core_sleep();
-    }
-    if( pid != 1 ) 
-    {
-        printk("\n[PANIC] in %s : process PID must be 0x1\n", __FUNCTION__ );
-        hal_core_sleep();
-    }
-
-    // initialize process descriptor / parent is local process_zero
-    error = process_reference_init( process,
-                                    pid,
-                                    XPTR( local_cxy , &process_zero ) );  
-    if( error )
-    {
-        printk("\n[PANIC] in %s : cannot initialize process\n", __FUNCTION__ );
-        hal_core_sleep();
-    }
-
-#if(DEBUG_PROCESS_INIT_CREATE & 1)
-if( DEBUG_PROCESS_INIT_CREATE < cycle )
-printk("\n[%s] thread[%x,%x] initialized process descriptor\n",
-__FUNCTION__, this->process->pid, this->trdid );
-#endif
-
-    // open the file identified by CONFIG_PROCESS_INIT_PATH
-    file_xp = XPTR_NULL;
-    file_id = -1;
-	error   = vfs_open( process->vfs_root_xp,
-	                    CONFIG_PROCESS_INIT_PATH,
-                        XPTR( local_cxy , process ),
-	                    O_RDONLY,
-	                    0,
-	                    &file_xp,
-	                    &file_id );
-    if( error )
-    {
-        printk("\n[PANIC] in %s : cannot open file <%s>\n",
-         __FUNCTION__, CONFIG_PROCESS_INIT_PATH  );
-        hal_core_sleep();
-    }
-
-#if(DEBUG_PROCESS_INIT_CREATE & 1)
-if( DEBUG_PROCESS_INIT_CREATE < cycle )
-printk("\n[%s] thread[%x,%x] open .elf file decriptor\n",
-__FUNCTION__, this->process->pid, this->trdid );
-#endif
-
-    // register "code" and "data" vsegs as well as entry-point
-    // in process VMM, using information contained in the elf file.
-	error = elf_load_process( file_xp , process );
-
-    if( error ) 
-    {
-        printk("\n[PANIC] in %s : cannot access file <%s>\n",
-         __FUNCTION__, CONFIG_PROCESS_INIT_PATH  );
-        hal_core_sleep();
-    }
-
-
-#if(DEBUG_PROCESS_INIT_CREATE & 1)
-if( DEBUG_PROCESS_INIT_CREATE < cycle )
-{
-    printk("\n[%s] thread[%x,%x] registered code/data vsegs in VMM\n",
-    __FUNCTION__, this->process->pid, this->trdid );
-    hal_vmm_display( XPTR( local_cxy , process ) , true );
-}
-#endif
-
-    // get extended pointers on process_zero children_root, children_lock
-    xptr_t children_root_xp = XPTR( local_cxy , &process_zero.children_root );
-    xptr_t children_lock_xp = XPTR( local_cxy , &process_zero.children_lock );
-
-    // take lock protecting kernel process children list
-    remote_queuelock_acquire( children_lock_xp );
-
-    // register process INIT in parent local process_zero 
-	xlist_add_last( children_root_xp , XPTR( local_cxy , &process->children_list ) );
-	hal_atomic_add( &process_zero.children_nr , 1 );
-
-    // release lock protecting kernel process children list
-    remote_queuelock_release( children_lock_xp );
-
-#if(DEBUG_PROCESS_INIT_CREATE & 1)
-if( DEBUG_PROCESS_INIT_CREATE < cycle )
-printk("\n[%s] thread[%x,%x] registered init process in parent\n",
-__FUNCTION__, this->process->pid, this->trdid );
-#endif
-
-    // select a core in local cluster to execute the main thread
-    lid  = cluster_select_local_core( local_cxy );
-
-    // initialize pthread attributes for main thread
-    attr.attributes = PT_ATTR_DETACH | PT_ATTR_CLUSTER_DEFINED | PT_ATTR_CORE_DEFINED;
-    attr.cxy        = local_cxy;
-    attr.lid        = lid;
-
-    // create and initialize thread descriptor
-	error = thread_user_create( pid,
-                                (void *)process->vmm.entry_point,
-                                NULL,
-                                &attr,
-                                &thread );
-
-    if( error )
-    {
-        printk("\n[PANIC] in %s : cannot create main thread\n", __FUNCTION__  );
-        hal_core_sleep();
-    }
-    if( thread->trdid != 0 )
-    {
-        printk("\n[PANIC] in %s : bad main thread trdid\n", __FUNCTION__  );
-        hal_core_sleep();
-    }
-
-#if(DEBUG_PROCESS_INIT_CREATE & 1)
-if( DEBUG_PROCESS_INIT_CREATE < cycle )
-printk("\n[%s] thread[%x,%x] created main thread\n",
-__FUNCTION__, this->process->pid, this->trdid );
-#endif
-
-    // activate thread
-	thread_unblock( XPTR( local_cxy , thread ) , THREAD_BLOCKED_GLOBAL );
-
-    hal_fence();
-
-#if DEBUG_PROCESS_INIT_CREATE
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_PROCESS_INIT_CREATE < cycle )
-printk("\n[%s] thread[%x,%x] exit / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, cycle );
-#endif
-
-}  // end process_init_create()
-
-///////////////////////////////////////////////////
-uint32_t process_build_string( xptr_t   process_xp,
-                               char   * buffer,
-                               uint32_t size )
-{
-    int32_t       length;          // actual length of the string
-
-    process_t   * process_ptr;     // process descriptor local pointer
-    cxy_t         process_cxy;     // process descriptor cluster identifier
-
-    xptr_t        parent_xp;       // extended pointer on parent process
-    process_t   * parent_ptr;      // parent process local pointer
-    cxy_t         parent_cxy;      // parent process cluster identifier
-
-    xptr_t        owner_xp;        // extended pointer on owner process
-    process_t   * owner_ptr;       // owner process local pointer
-    cxy_t         owner_cxy;       // owner process cluster identifier
-
-    pid_t         pid;             // process identifier
-    pid_t         ppid;            // parent process identifier
-    lpid_t        lpid;            // local process identifier
-    uint32_t      state;           // terminaison state
-    uint32_t      th_nr;           // number of threads
-
-    xptr_t        txt_file_xp;     // extended pointer on TXT_RX file descriptor
-    xptr_t        txt_chdev_xp;    // extended pointer on TXT_RX chdev
-    chdev_t     * txt_chdev_ptr;
-    cxy_t         txt_chdev_cxy;
-    xptr_t        txt_owner_xp;    // extended pointer on TXT owner process 
-
-    xptr_t        elf_file_xp;     // extended pointer on .elf file 
-    cxy_t         elf_file_cxy;
-    vfs_file_t  * elf_file_ptr;
-    vfs_inode_t * elf_inode_ptr;   // local pointer on .elf inode
-
-    char          txt_name[CONFIG_VFS_MAX_NAME_LENGTH];
-    char          elf_name[CONFIG_VFS_MAX_NAME_LENGTH];
-
-assert( __FUNCTION__ , (size >= 80 ) , "buffer size too small" );
-
-    // get cluster and local pointer on process
-    process_ptr = GET_PTR( process_xp );
-    process_cxy = GET_CXY( process_xp );
-
-    // get process PID, LPID, and state
-    pid   = hal_remote_l32( XPTR( process_cxy , &process_ptr->pid ) );
-    lpid  = LPID_FROM_PID( pid );
-    state = hal_remote_l32( XPTR( process_cxy , &process_ptr->term_state ) );
-
-    // get process PPID
-    parent_xp  = hal_remote_l64( XPTR( process_cxy , &process_ptr->parent_xp ) );
-    parent_cxy = GET_CXY( parent_xp );
-    parent_ptr = GET_PTR( parent_xp );
-    ppid       = hal_remote_l32( XPTR( parent_cxy , &parent_ptr->pid ) );
-
-    // get number of threads
-    th_nr      = hal_remote_l32( XPTR( process_cxy , &process_ptr->th_nr ) );
-
-    // get pointers on owner process descriptor
-    owner_xp  = hal_remote_l64( XPTR( process_cxy , &process_ptr->owner_xp ) );
-    owner_cxy = GET_CXY( owner_xp );
-    owner_ptr = GET_PTR( owner_xp );
-
-    // get process TXT name and .elf name
-    if( lpid )                                   // user process
-    {
-        // get extended pointer on file descriptor associated to TXT_RX 
-        txt_file_xp = hal_remote_l64( XPTR( owner_cxy , &owner_ptr->fd_array.array[0] ) );
-
-assert( __FUNCTION__, (txt_file_xp != XPTR_NULL) ,
-"process must be attached to one TXT terminal" ); 
-
-        // get TXT_RX chdev pointers
-        txt_chdev_xp  = chdev_from_file( txt_file_xp );
-        txt_chdev_cxy = GET_CXY( txt_chdev_xp );
-        txt_chdev_ptr = GET_PTR( txt_chdev_xp );
-
-        // get TXT_RX name and ownership
-        hal_remote_strcpy( XPTR( local_cxy , txt_name ) ,
-                           XPTR( txt_chdev_cxy , txt_chdev_ptr->name ) );
-    
-        // get TXT_owner process
-        txt_owner_xp = (xptr_t)hal_remote_l64( XPTR( txt_chdev_cxy, 
-                                                     &txt_chdev_ptr->ext.txt.owner_xp ) );
-        // get process .elf name
-        elf_file_xp   = hal_remote_l64( XPTR( process_cxy , &process_ptr->vfs_bin_xp ) );
-        elf_file_cxy  = GET_CXY( elf_file_xp );
-        elf_file_ptr  = GET_PTR( elf_file_xp );
-        elf_inode_ptr = hal_remote_lpt( XPTR( elf_file_cxy , &elf_file_ptr->inode ) );
-        vfs_inode_get_name( XPTR( elf_file_cxy , elf_inode_ptr ) , elf_name );
-    }
-    else                                         // kernel process_zero
-    {
-        // TXT name and .elf name are not registered in kernel process
-        strcpy( txt_name , "txt0_rx" );
-        txt_owner_xp = process_xp; 
-        strcpy( elf_name , "kernel.elf" );
-    }
-
-    // display process info
-    if( txt_owner_xp == process_xp )
-    {
-        length = snprintk( buffer, size,
-        "PID %X | %s (FG) | %X | PPID %X | TS %X | %d | %s\n", 
-        pid, txt_name, process_ptr, ppid, state, th_nr, elf_name );
-    }
-    else
-    {
-        length = snprintk( buffer, size,
-        "PID %X | %s (BG) | %X | PPID %X | TS %X | %d | %s\n", 
-        pid, txt_name, process_ptr, ppid, state, th_nr, elf_name );
-    }
-
-    // check length 
-    if( (length < 0) )
-    {
-        length = snprintk( buffer , size , 
-        "buffer too small for process %x in cluster %x", pid , process_cxy );
-    }
-
-    return length;  
-
-}  // end process_build_string()
-
-/////////////////////////////////////////
-void process_display( xptr_t process_xp )
-{
-    char  buffer[CONFIG_PROCESS_DISPLAY_BUF_SIZE];
-
-    // build the string to be displayed
-    process_build_string( process_xp,
-                          buffer,
-                          CONFIG_PROCESS_DISPLAY_BUF_SIZE ); 
-    // display the string
-    nolock_puts( buffer );
-
-}  // end process_display() 
-
-
-////////////////////////////////////////////////////////////////////////////////////////
-//     Terminals related functions
-////////////////////////////////////////////////////////////////////////////////////////
-
-//////////////////////////////////
-uint32_t process_txt_alloc( void )
-{
-    uint32_t  index;       // TXT terminal index
-    xptr_t    chdev_xp;    // extended pointer on TXT_RX chdev
-    chdev_t * chdev_ptr;   // local pointer on TXT_RX chdev
-    cxy_t     chdev_cxy;   // TXT_RX chdev cluster
-    xptr_t    root_xp;     // extended pointer on owner field in chdev
-
-    // scan the user TXT_RX chdevs (TXT0 is reserved for kernel)
-    for( index = 1 ; index < LOCAL_CLUSTER->nb_txt_channels ; index ++ )
-    {
-        // get pointers on TXT_RX[index]
-        chdev_xp  = chdev_dir.txt_rx[index];
-        chdev_cxy = GET_CXY( chdev_xp );
-        chdev_ptr = GET_PTR( chdev_xp );
-
-        // get extended pointer on root of attached process
-        root_xp = XPTR( chdev_cxy , &chdev_ptr->ext.txt.root );
-
-        // return free TXT index if found
-        if( xlist_is_empty( root_xp ) ) return index;  
-    }
-
-    assert( __FUNCTION__, false , "no free TXT terminal found" );
-
-    return -1;
-
-} // end process_txt_alloc()
-
-/////////////////////////////////////////////
-void process_txt_attach( xptr_t   process_xp,
-                         uint32_t txt_id )
-{
-    xptr_t      chdev_xp;     // extended pointer on TXT_RX chdev
-    cxy_t       chdev_cxy;    // TXT_RX chdev cluster
-    chdev_t *   chdev_ptr;    // local pointer on TXT_RX chdev
-    xptr_t      root_xp;      // extended pointer on list root in chdev
-    xptr_t      lock_xp;      // extended pointer on list lock in chdev
-
-    process_t * process_ptr = GET_PTR(process_xp );
-    cxy_t       process_cxy = GET_CXY(process_xp );
-
-// check process is in owner cluster
-assert( __FUNCTION__, (process_xp == hal_remote_l64( XPTR( process_cxy , &process_ptr->owner_xp ))),
-"process descriptor not in owner cluster" );
-
-// check terminal index
-assert( __FUNCTION__, (txt_id < LOCAL_CLUSTER->nb_txt_channels) ,
-"illegal TXT terminal index" );
-
-    // get pointers on TXT_RX[txt_id] chdev
-    chdev_xp  = chdev_dir.txt_rx[txt_id];
-    chdev_cxy = GET_CXY( chdev_xp );
-    chdev_ptr = GET_PTR( chdev_xp );
-
-    // get extended pointer on root & lock of attached process list
-    root_xp = XPTR( chdev_cxy , &chdev_ptr->ext.txt.root );
-    lock_xp = XPTR( chdev_cxy , &chdev_ptr->ext.txt.lock );
-
-    // get lock protecting list of processes attached to TXT
-    remote_busylock_acquire( lock_xp );
-
-    // insert owner process in list of attached processes to same TXT
-    xlist_add_last( root_xp , XPTR( process_cxy , &process_ptr->txt_list ) );
-
-    // release lock protecting list of processes attached to TXT
-    remote_busylock_release( lock_xp );
-
-#if DEBUG_PROCESS_TXT
-thread_t * this = CURRENT_THREAD;
-uint32_t cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_PROCESS_TXT < cycle )
-printk("\n[%s] thread[%x,%x] attached process %x to TXT %d / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid,
-hal_remote_l32( XPTR( process_cxy , &process_ptr->pid, txt_id , cycle );
-#endif
-
-} // end process_txt_attach()
-
-/////////////////////////////////////////////
-void process_txt_detach( xptr_t  process_xp )
-{
-    process_t * process_ptr;  // local pointer on process in owner cluster
-    cxy_t       process_cxy;  // process owner cluster
-    pid_t       process_pid;  // process identifier
-    xptr_t      file_xp;      // extended pointer on stdin file
-    xptr_t      chdev_xp;     // extended pointer on TXT_RX chdev
-    cxy_t       chdev_cxy;    // TXT_RX chdev cluster
-    chdev_t *   chdev_ptr;    // local pointer on TXT_RX chdev
-    xptr_t      lock_xp;      // extended pointer on list lock in chdev
-
-    // get process cluster, local pointer, and PID
-    process_cxy = GET_CXY( process_xp );
-    process_ptr = GET_PTR( process_xp );
-    process_pid = hal_remote_l32( XPTR( process_cxy , &process_ptr->pid ) );
-
-// check process descriptor in owner cluster
-assert( __FUNCTION__, (CXY_FROM_PID( process_pid ) == process_cxy ) ,
-"process descriptor not in owner cluster" );
-
-    // release TXT ownership (does nothing if not TXT owner)
-    process_txt_transfer_ownership( process_xp );
-
-    // get extended pointer on process stdin pseudo file
-    file_xp = (xptr_t)hal_remote_l64( XPTR( process_cxy , &process_ptr->fd_array.array[0] ) );
-
-    // get pointers on TXT_RX chdev
-    chdev_xp  = chdev_from_file( file_xp );
-    chdev_cxy = GET_CXY( chdev_xp );
-    chdev_ptr = (chdev_t *)GET_PTR( chdev_xp );
-
-    // get extended pointer on lock protecting attached process list
-    lock_xp = XPTR( chdev_cxy , &chdev_ptr->ext.txt.lock );
-
-    // get lock protecting list of processes attached to TXT
-    remote_busylock_acquire( lock_xp );
-
-    // unlink process from attached process list
-    xlist_unlink( XPTR( process_cxy , &process_ptr->txt_list ) );
-
-    // release lock protecting list of processes attached to TXT
-    remote_busylock_release( lock_xp );
-
-#if DEBUG_PROCESS_TXT
-thread_t * this = CURRENT_THREAD;
-uint32_t cycle  = (uint32_t)hal_get_cycles();
-uint32_t txt_id = hal_remote_l32( XPTR( chdev_cxy , &chdev_ptr->channel ) );
-if( DEBUG_PROCESS_TXT < cycle )
-printk("\n[%s] thread[%x,%x] detached process %x from TXT%d / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, process_pid, txt_id, cycle );
-#endif
-
-} // end process_txt_detach()
-
-///////////////////////////////////////////////////
-uint32_t process_txt_get_index( xptr_t process_xp )
-{
-
-    // get target process cluster and local pointer
-    process_t * process_ptr = GET_PTR( process_xp );
-    cxy_t       process_cxy = GET_CXY( process_xp );
-
-assert( __FUNCTION__, (process_xp == hal_remote_l64( XPTR( process_cxy , &process_ptr->owner_xp))),
-"process descriptor not in owner cluster" );
-
-    // get extended pointer on STDIN pseudo file in owner process descriptor
-    xptr_t file_xp = hal_remote_l64( XPTR( process_cxy , &process_ptr->fd_array.array[0]));
-
-assert( __FUNCTION__, (file_xp != XPTR_NULL),
-"STDIN pseudo-file undefined in fd_array for process %x\n",
-hal_remote_l32( XPTR( process_cxy , &process_ptr->pid ) ) );
-
-    // get extended pointer on TXT chdev
-    xptr_t chdev_xp = chdev_from_file( file_xp );
- 
-assert( __FUNCTION__, (chdev_xp != XPTR_NULL),
-"chdev undefined for STDIN pseudo-file of process %x\n",
-hal_remote_l32( XPTR( process_cxy , &process_ptr->pid ) ) );
-
-    // get cluster and local pointer on chdev
-   cxy_t     chdev_cxy = GET_CXY( chdev_xp );
-   chdev_t * chdev_ptr = GET_PTR( chdev_xp );
- 
-   // get parent TXT terminal index
-   return hal_remote_l32( XPTR( chdev_cxy , &chdev_ptr->channel ) );
-
-}  // end process_txt_get_index()
-
-///////////////////////////////////////////////////
-void process_txt_set_ownership( xptr_t process_xp )
-{
-    process_t * process_ptr;
-    cxy_t       process_cxy;
-    xptr_t      file_xp;
-    xptr_t      txt_xp;     
-    chdev_t   * txt_ptr;
-    cxy_t       txt_cxy;
-
-    // get pointers on process in owner cluster
-    process_cxy = GET_CXY( process_xp );
-    process_ptr = GET_PTR( process_xp );
-
-    // check owner cluster
-    assert( __FUNCTION__, (process_xp == hal_remote_l64( XPTR( process_cxy , &process_ptr->owner_xp ))),
-    "process descriptor not in owner cluster" );
-
-    // get extended pointer on stdin pseudo file
-    file_xp = hal_remote_l64( XPTR( process_cxy , &process_ptr->fd_array.array[0] ) );
-
-    // get pointers on TXT chdev
-    txt_xp  = chdev_from_file( file_xp );
-    txt_cxy = GET_CXY( txt_xp );
-    txt_ptr = GET_PTR( txt_xp );
-
-    // set owner field in TXT chdev
-    hal_remote_s64( XPTR( txt_cxy , &txt_ptr->ext.txt.owner_xp ) , process_xp );
-
-#if DEBUG_PROCESS_TXT
-thread_t * this = CURRENT_THREAD;
-uint32_t cycle  = (uint32_t)hal_get_cycles();
-uint32_t txt_id = hal_remote_l32( XPTR( txt_cxy , &txt_ptr->channel ) );
-if( DEBUG_PROCESS_TXT < cycle )
-printk("\n[%s] thread[%x,%x] give TXT%d ownership to process / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, txt_id, cycle );
-#endif
-
-}  // end process_txt_set ownership()
-
-////////////////////////////////////////////////////////
-void process_txt_transfer_ownership( xptr_t process_xp )
-{
-    process_t * process_ptr;     // local pointer on process releasing ownership
-    cxy_t       process_cxy;     // process cluster
-    pid_t       process_pid;     // process identifier
-    xptr_t      file_xp;         // extended pointer on TXT_RX pseudo file
-    xptr_t      txt_xp;          // extended pointer on TXT_RX chdev
-    chdev_t   * txt_ptr;         // local pointer on TXT_RX chdev
-    cxy_t       txt_cxy;         // cluster of TXT_RX chdev
-    uint32_t    txt_id;          // TXT_RX channel 
-    xptr_t      owner_xp;        // extended pointer on current TXT_RX owner
-    xptr_t      root_xp;         // extended pointer on root of attached process list
-    xptr_t      lock_xp;         // extended pointer on lock protecting attached process list
-    xptr_t      iter_xp;         // iterator for xlist
-    xptr_t      current_xp;      // extended pointer on current process
-    bool_t      found;
-
-#if DEBUG_PROCESS_TXT
-thread_t * this  = CURRENT_THREAD;
-uint32_t   cycle;
-#endif
-
-    // get pointers on target process 
-    process_cxy = GET_CXY( process_xp );
-    process_ptr = GET_PTR( process_xp );
-    process_pid = hal_remote_l32( XPTR( process_cxy , &process_ptr->pid ) );
-
-// check owner cluster
-assert( __FUNCTION__, (process_cxy == CXY_FROM_PID( process_pid )) ,
-"process descriptor not in owner cluster" );
-
-    // get extended pointer on stdin pseudo file
-    file_xp = hal_remote_l64( XPTR( process_cxy , &process_ptr->fd_array.array[0] ) );
-
-    // get pointers on TXT chdev
-    txt_xp  = chdev_from_file( file_xp );
-    txt_cxy = GET_CXY( txt_xp );
-    txt_ptr = GET_PTR( txt_xp );
-
-    // get relevant infos from chdev descriptor
-    owner_xp = hal_remote_l64( XPTR( txt_cxy , &txt_ptr->ext.txt.owner_xp ) );
-    txt_id   = hal_remote_l32( XPTR( txt_cxy , &txt_ptr->channel ) );
-
-    // transfer ownership only if target process is the TXT owner
-    if( (owner_xp == process_xp) && (txt_id > 0) )  
-    {
-        // get extended pointers on root and lock of attached processes list
-        root_xp = XPTR( txt_cxy , &txt_ptr->ext.txt.root );
-        lock_xp = XPTR( txt_cxy , &txt_ptr->ext.txt.lock );
-
-        if( process_get_ppid( process_xp ) != 1 )       // target process is not KSH
-        {
-            // get lock
-            remote_busylock_acquire( lock_xp );
-
-            // scan attached process list to find KSH process
-            found = false;
-            for( iter_xp = hal_remote_l64( root_xp ) ;
-                 (iter_xp != root_xp) && (found == false) ;
-                 iter_xp = hal_remote_l64( iter_xp ) )
-            {
-                current_xp = XLIST_ELEMENT( iter_xp , process_t , txt_list );
-
-                if( process_get_ppid( current_xp ) == 1 )  // current is KSH 
-                {
-                    // set owner field in TXT chdev 
-                    hal_remote_s64( XPTR( txt_cxy , &txt_ptr->ext.txt.owner_xp ) , current_xp );
-
-#if DEBUG_PROCESS_TXT
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_PROCESS_TXT < cycle )
-printk("\n[%s] thread[%x,%x] transfered TXT%d ownership to KSH / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, txt_id, cycle );
-#endif
-                    found = true;
-                }
-            }
-
-            // release lock
-            remote_busylock_release( lock_xp );
-
-// It must exist a KSH process for each user TXT channel
-assert( __FUNCTION__, (found == true), "KSH process not found for TXT%d", txt_id );
-
-        }
-        else                                           // target process is KSH
-        {
-            // get lock
-            remote_busylock_acquire( lock_xp );
-
-            // scan attached process list to find another process 
-            found = false;
-            for( iter_xp = hal_remote_l64( root_xp ) ;
-                 (iter_xp != root_xp) && (found == false) ;
-                 iter_xp = hal_remote_l64( iter_xp ) )
-            {
-                current_xp  = XLIST_ELEMENT( iter_xp , process_t , txt_list );
-
-                if( current_xp != process_xp )            // current is not KSH 
-                {
-                    // set owner field in TXT chdev 
-                    hal_remote_s64( XPTR( txt_cxy , &txt_ptr->ext.txt.owner_xp ) , current_xp );
-
-#if DEBUG_PROCESS_TXT
-cycle  = (uint32_t)hal_get_cycles();
-cxy_t       current_cxy = GET_CXY( current_xp );
-process_t * current_ptr = GET_PTR( current_xp );
-uint32_t    new_pid     = hal_remote_l32( XPTR( current_cxy , &current_ptr->pid ) );
-if( DEBUG_PROCESS_TXT < cycle )
-printk("\n[%s] thread[%x,%x] transfered TXT%d ownership to process %x / cycle %d\n",
-__FUNCTION__,this->process->pid, this->trdid, txt_id, new_pid, cycle );
-#endif
-                    found = true;
-                }
-            }
-
-            // release lock
-            remote_busylock_release( lock_xp );
-
-            // no more owner for TXT if no other process found
-            if( found == false )
-            {
-                // set owner field in TXT chdev 
-                hal_remote_s64( XPTR( txt_cxy , &txt_ptr->ext.txt.owner_xp ) , XPTR_NULL );
-
-#if DEBUG_PROCESS_TXT
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_PROCESS_TXT < cycle )
-printk("\n[%s] thread[%x,%x] released TXT%d (no attached process) / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, txt_id, cycle );
-#endif
-            }
-        }
-    }
-    else
-    {
-
-#if DEBUG_PROCESS_TXT
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_PROCESS_TXT < cycle )
-printk("\n[%s] thread[%x,%x] does nothing for process %x (not TXT owner) / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, process_pid, cycle );
-#endif
-
-    }
-
-}  // end process_txt_transfer_ownership()
-
-
-////////////////////////////////////////////////
-bool_t process_txt_is_owner( xptr_t process_xp )
-{
-    // get local pointer and cluster of process in owner cluster
-    cxy_t       process_cxy = GET_CXY( process_xp );
-    process_t * process_ptr = GET_PTR( process_xp );
-
-// check calling thread execute in target process owner cluster
-pid_t process_pid = hal_remote_l32( XPTR( process_cxy , &process_ptr->pid ) );
-assert( __FUNCTION__, (process_cxy == CXY_FROM_PID( process_pid )) ,
-"process descriptor not in owner cluster" );
-
-    // get extended pointer on stdin pseudo file
-    xptr_t file_xp = hal_remote_l64( XPTR( process_cxy , &process_ptr->fd_array.array[0] ) );
-
-    // get pointers on TXT chdev
-    xptr_t    txt_xp  = chdev_from_file( file_xp );
-    cxy_t     txt_cxy = GET_CXY( txt_xp );
-    chdev_t * txt_ptr = GET_PTR( txt_xp );
-
-    // get extended pointer on TXT_RX owner process 
-    xptr_t owner_xp = hal_remote_l64( XPTR( txt_cxy , &txt_ptr->ext.txt.owner_xp ) );
-
-    return (process_xp == owner_xp);
-
-}   // end process_txt_is_owner()
-
-////////////////////////////////////////////////     
-xptr_t process_txt_get_owner( uint32_t channel )
-{
-    xptr_t      txt_rx_xp  = chdev_dir.txt_rx[channel];
-    cxy_t       txt_rx_cxy = GET_CXY( txt_rx_xp );
-    chdev_t *   txt_rx_ptr = GET_PTR( txt_rx_xp );
-
-    return (xptr_t)hal_remote_l64( XPTR( txt_rx_cxy , &txt_rx_ptr->ext.txt.owner_xp ) );
-
-}  // end process_txt_get_owner()
-
-///////////////////////////////////////////
-void process_txt_display( uint32_t txt_id )
-{
-    xptr_t      chdev_xp;
-    cxy_t       chdev_cxy;
-    chdev_t   * chdev_ptr;
-    xptr_t      root_xp;
-    xptr_t      lock_xp;
-    xptr_t      current_xp;
-    xptr_t      iter_xp;
-    cxy_t       txt0_cxy;
-    chdev_t   * txt0_ptr;
-    xptr_t      txt0_xp;
-    xptr_t      txt0_lock_xp;
-    
-    assert( __FUNCTION__, (txt_id < LOCAL_CLUSTER->nb_txt_channels) ,
-    "illegal TXT terminal index" );
-
-    // get pointers on TXT0 chdev
-    txt0_xp  = chdev_dir.txt_tx[0];
-    txt0_cxy = GET_CXY( txt0_xp );
-    txt0_ptr = GET_PTR( txt0_xp );
-
-    // get extended pointer on TXT0 lock
-    txt0_lock_xp = XPTR( txt0_cxy , &txt0_ptr->wait_lock );
-
-    // get pointers on TXT_RX[txt_id] chdev
-    chdev_xp  = chdev_dir.txt_rx[txt_id];
-    chdev_cxy = GET_CXY( chdev_xp );
-    chdev_ptr = GET_PTR( chdev_xp );
-
-    // get extended pointer on root & lock of attached process list
-    root_xp = XPTR( chdev_cxy , &chdev_ptr->ext.txt.root );
-    lock_xp = XPTR( chdev_cxy , &chdev_ptr->ext.txt.lock );
-
-    // get lock on attached process list
-    remote_busylock_acquire( lock_xp );
-
-    // get TXT0 lock in busy waiting mode
-    remote_busylock_acquire( txt0_lock_xp );
-
-    // display header
-    nolock_printk("\n***** processes attached to TXT_%d / cycle %d\n",
-    txt_id , (uint32_t)hal_get_cycles() );
-
-    // scan attached process list 
-    XLIST_FOREACH( root_xp , iter_xp )
-    {
-        current_xp  = XLIST_ELEMENT( iter_xp , process_t , txt_list );
-        process_display( current_xp );
-    }
-
-    // release TXT0 lock in busy waiting mode
-    remote_busylock_release( txt0_lock_xp );
-
-    // release lock on attached process list
-    remote_busylock_release( lock_xp );
-
-}  // end process_txt_display
+    // register stdin / stdout / stderr in the fd_array 3 first slots 
+	process_init->fd_array.array[0] = stdin_xp;
+	process_init->fd_array.array[1] = stdout_xp;
+	process_init->fd_array.array[2] = stderr_xp;
+    process_init->fd_array.current  = 3;
+
+    // initialize the exec_info structure
+    exec_info.pid          = process_init->pid;
+    exec_info.ppid         = process_init->ppid;
+    exec_info.fd_array_xp  = XPTR( local_cxy , &process_init->fd_array );
+    exec_info.vfs_root_xp  = process_init->vfs_root_xp;
+    exec_info.vfs_cwd_xp   = process_init->vfs_cwd_xp;
+    exec_info.vfs_bin_xp   = process_init->vfs_bin_xp;
+
+    // TODO thread_init ???
+    // exec_info.args_nr      = 1;
+    // exec_info.envs_nr      = 1;
+    // strcpy( exec_info.args[0] , "init" );
+    // strcpy( exec_info.envs[0] , "ALMOS-MKH.CONFIG = "CONFIG_ALMOS_VERSION );
+    // strcpy( exec_info.path    , INIT_PATHNAME );
+
+    // create process_init and thread_init
+	error1 = process_make_exec( &exec_info );
+	if( error1 )
+	{
+        printk("\n[PANIC] in %s : cannot create main thread in cluster %x\n",
+               __FUNCTION__ , local_cxy );
+		hal_core_sleep();
+    }
+
+	process_dmsg("\n[INFO] %s successfully exit in cluster %x\n", __FUNCTION__ , local_cxy );
+		
+    hal_wbflush();
+
+} // end process_init_create()
+
+
